unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, AfDataDispatcher, AfComPort, StdCtrls, AfPortControls, ExtCtrls;

type
  TForm1 = class(TForm)
    AfComPort1: TAfComPort;

    Button1: TButton;
    Memo1: TMemo;
    Label1: TLabel;
    Button2: TButton;
    Label3: TLabel;
    Memo2: TMemo;
    Timer1: TTimer;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    

  
  private
    { Private declarations }
  public
        Function CalculoCS(Comando: Pchar): String;
        Function Send (Comando:string): String;
        Function LeituraBuffer(): String;
    { Public declarations }
  end;

var
  Form1: TForm1;
  Flag: Boolean;
implementation

{$R *.dfm}

Function TForm1.Send (Comando:string): String;     // Envia o Comando
Var Checksum : String;
    TComando: string;
    TResposta:string;
    retorno:string;
    BufferIn: integer;
    i: integer;
    ACK: Pchar;
Begin

       TComando:=#2+Comando+#3;
       Checksum:=CalculoCS(Pchar(TComando)); // calculo do checksum
       TComando:= TComando+ Checksum ;
       AfComPort1.Open;
       AfComPort1.PurgeRX;
       AfComPort1.PurgeTX;
       TResposta:='';
       AfComPort1.WriteString(TComando);
       BufferIn:= AfComPort1.InBufUsed;

       while BufferIn =0 do BufferIn:= AfComPort1.InBufUsed;  // Verificando o Buffer


       retorno:= AfComPort1.ReadString;
       ACK:= Pchar(retorno);

       If ACK= #6 then
       begin
            memo2.Lines.Add(TComando);
            TResposta:=LeituraBuffer; // Leitura do buffer

           If Length(TResposta)<5 then showmessage('Erro no Checksum de Resposta!!!')
           Else If (TResposta[5]= '+') or (TResposta[5]= '-')then
                Begin
                    Send:= Copy(TResposta,6, 4);
                    memo1.Lines.Add(TResposta);
                End
           Else If (TResposta[5]= '!') then Showmessage('Alterao de Status:'+TResposta);
       end
       Else if ACK = #21 THEN   // Nak
           begin
                showmessage('Retorno de erro NAK');
                Result:='#21';
           End;


end;

Function TForm1.CalculoCS(Comando: Pchar): String;   // Calculo do Checksum
 var i: integer;
     Cont: integer;
 Begin
     Cont:=0;
     For i:=0 to 2000 do
        Begin
            If Comando[i]= #0 then break;
            Cont:= Cont+ Ord(Comando[i]);
        end;
        Cont:= Cont Mod 256;

    CalculoCS:=chr(Cont);
 End;

procedure TForm1.Button1Click(Sender: TObject);    // Leitura de Status
 Var Resposta: String;
begin
     Resposta:= Send('*15');
     If Resposta <> '0000' then showmessage('Erro: ' + Resposta);

end;


procedure TForm1.Button2Click(Sender: TObject);  // Cupom Fiscal

      Var Resposta: String;
      i:integer;
begin
     Resposta:= Send('*01');
     If Resposta <> '0000' then showmessage('Erro: ' + Resposta);
     //for i:=1 to 10 do
     Resposta:= Send('*02|1|00000000000001|1,00|Un|T12,00%|teste');
     If Resposta <> '0000' then showmessage('Erro: ' + Resposta);
     Resposta:= Send('*06|1|11,00');
     If Resposta <> '0000' then showmessage('Erro: ' + Resposta);
     Resposta:= Send('*07|volte sempre!!!');
     If Resposta <> '0000' then showmessage('Erro: ' + Resposta);
end;

Function TForm1.LeituraBuffer(): String;  // Leitura do Buffer
  Var Checksum : String;
      TResposta:string;
    retorno:string;
    tam: integer;
    LerBuffer:integer;
    
begin
Lerbuffer:=1;
while LerBuffer =1 do
                begin
                      retorno:= AfComPort1.readstring;
                      tam:=Length(retorno);
                      if (tam>3) and (retorno[tam-1] = #3) then   // Etx
                           begin
                                 TResposta := TResposta+ Copy(retorno,1, tam-1);
                                 Checksum:=CalculoCS(Pchar(TResposta));
                                 if Checksum = retorno[tam] then
                                  Begin

                                      TResposta:=TResposta+ retorno[tam];
                                      LerBuffer:=0;
                                      Result:=TResposta;
                                      AfComPort1.WriteChar(Char (6)); // enviar ACK para confirmar a leitura da REsposta
                                      break;

                                  end
                                  else
                                  begin
                                        Result:='#21';
                                        AfComPort1.WriteChar(Char (21)); // enviar NACK para erro de leitura da REsposta
                                        LerBuffer:=0;
                                        break;
                                  end;

                           end

                           else if tam =0 then sleep (100)
                           else
                                begin
                                        TResposta:=TResposta+retorno;

                                end;
               end;



       
end;
procedure TForm1.Timer1Timer(Sender: TObject);  // Alterao de Status
Var
    TResposta: STRING;
    buf:integer;
begin
        buf:= AfComPort1.InBufUsed;
        IF buf > 0 THEN
            begin
                TResposta:= LeituraBuffer;
                If (TResposta[5]= '!')then Showmessage('Alterao de Status:'+TResposta)
                Else If (TResposta[5]= '+') or (TResposta[5]= '-')then
                Begin

                    If Copy(TResposta,6, 4) <> '0000' then showmessage('Erro: ' + Copy(TResposta,6, 4));
                    memo1.Lines.Add(TResposta);
                End
            end;    
end;

procedure TForm1.RadioButton1Click(Sender: TObject);  // Com 1
begin
      AfComPort1.ComNumber:=1;
      AfComPort1.Open;
end;

procedure TForm1.RadioButton2Click(Sender: TObject);  // Com 2
begin
        AfComPort1.ComNumber:=2;
        AfComPort1.Open;
end;

procedure TForm1.RadioButton3Click(Sender: TObject);  // // Com 3
begin
      AfComPort1.ComNumber:=3;
      AfComPort1.Open;
end;

procedure TForm1.RadioButton4Click(Sender: TObject);   // Com 4
begin
      AfComPort1.ComNumber:=4;
      AfComPort1.Open;
end;

procedure TForm1.Button3Click(Sender: TObject);     // Status do ECF
var Resposta: String;
begin

     Resposta:= Send('*34');

end;


procedure TForm1.FormCreate(Sender: TObject);
begin
        Showmessage('O Ecf deve est Ligado!!!' + #13 +'O Time-Out no est sendo Calculado!!!');
end;

end.
